       IDENTIFICATION DIVISION.
       PROGRAM-ID.    BINBITC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2016 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: BINBITC1.CBL
      *****************************************************************
      *
      * BINBITC1 - Create, Define and process binary tables.
      *
      * CALLING PROTOCOL
      * ----------------
      * Use standard procedure to RUN or ANIMATE.
      *
      * DESCRIPTION
      * -----------
      * This program will call a COBOL routine to access a
      * routine to convert between bits and bytes..
      *
      *          ************
      *          * BINBITJ1 *
      *          ********jcl*
      *               *
      *               *
      *          ************     ************
      *          * BINBITC1 *-----*  SYSOUT  *
      *          ********cbl*  *  ************
      *               *        *
      *               *        *  ************
      *               *        *--* HEXDECB1 *
      *               *           *******rseq*
      *               *        *
      *               *        *  ************
      *               *        *--* HEXDSPB1 *
      *               *           *******rseq*
      *          ************
      *          *   EOJ    *
      *          ********cbl*
      *
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      * 1997/03/17 Simmons, Updated for call to SIMOBITS.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT HEXDECB1-FILE  ASSIGN TO       HEXDECB1
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS HEXDECB1-STATUS.

           SELECT HEXDSPB1-FILE  ASSIGN TO       HEXDSPB1
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS HEXDSPB1-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  HEXDECB1-FILE
           DATA RECORD    IS HEXDECB1-REC
           .
       01  HEXDECB1-REC.
           05  HEXDECB1-DATA-01 PIC X(00080).

       FD  HEXDSPB1-FILE
           DATA RECORD    IS HEXDSPB1-REC
           .
       01  HEXDSPB1-REC.
           05  HEXDSPB1-DATA-01 PIC X(00080).

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* BINBITC1 '.
           05  T2 pic X(34) value 'Create Binary Data and Copy Files '.
           05  T3 pic X(10) value ' v08.03.13'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* BINBITC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2016 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* BINBITC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* BINBITC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  HEXDECB1-STATUS.
           05  HEXDECB1-STATUS-L     pic X.
           05  HEXDECB1-STATUS-R     pic X.
       01  HEXDECB1-EOF              pic X       value 'N'.
       01  HEXDECB1-OPEN-FLAG        pic X       value 'C'.

       01  HEXDSPB1-STATUS.
           05  HEXDSPB1-STATUS-L     pic X.
           05  HEXDSPB1-STATUS-R     pic X.
       01  HEXDSPB1-EOF              pic X       value 'N'.
       01  HEXDSPB1-OPEN-FLAG        pic X       value 'C'.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *    ------------------------------------------------------------
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* BINBITC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  IX-1           pic 9(3) value 0.
       01  IX-2           pic 9(3) value 0.
       01  IX-3           pic 9(3) value 0.

       01  BIN-WORK-256        pic X(256)  value LOW-VALUES.
       01  BIN-WORK-02A.
           05  BIN-WORK-02B    pic 9(3)    comp value 0.

       01  HEX-CHAR            pic X(16)   value '0123456789ABCDEF'.

       01  HEX-DECIMAL-GROUP.
           05  FILLER          PIC x(11) VALUE '       01  '.
           05  FILLER          PIC X(18) VALUE 'HEX-DECIMAL-GROUP.'.

       01  HEX-DECIMAL-TABLE.
           05  FILLER          PIC x(11) VALUE '       01  '.
           05  FILLER          PIC X(18) VALUE 'HEX-DECIMAL-REDEF '.
           05  FILLER          PIC X(06) VALUE SPACES.
           05  FILLER          PIC X(10) VALUE 'REDEFINES '.
           05  FILLER          PIC X(18) VALUE 'HEX-DECIMAL-GROUP.'.

       01  HEX-DECIMAL-TABLE-02.
           05  FILLER          PIC x(15) VALUE '           05  '.
           05  FILLER          PIC X(18) VALUE 'HEX-DECIMAL-TABLE '.
           05  FILLER          PIC X(02) VALUE SPACES.
           05  FILLER          PIC X(06) VALUE 'pic X '.
           05  FILLER          PIC X(18) VALUE 'OCCURS 256 TIMES. '.

       01  HEX-DECIMAL-BYTES.
           05  FILLER          PIC x(15) VALUE '           05  '.
           05  FILLER          PIC X(04) VALUE 'HEX-'.
           05  HEX-SYMBOL      PIC X(02) VALUE '00'.
           05  FILLER          PIC X(14) VALUE SPACES.
           05  FILLER          PIC X(15) VALUE "pic X  VALUE X'".
           05  HEX-VALUE       PIC X(02) VALUE '00'.
           05  FILLER          PIC X(02) VALUE "'.".

       01  HEX-DISPLAY-GROUP.
           05  FILLER          PIC x(11) VALUE '       01  '.
           05  FILLER          PIC X(18) VALUE 'HEX-DISPLAY-GROUP.'.

       01  HEX-DISPLAY-TABLE.
           05  FILLER          PIC x(11) VALUE '       01  '.
           05  FILLER          PIC X(18) VALUE 'HEX-DISPLAY-REDEF '.
           05  FILLER          PIC X(06) VALUE SPACES.
           05  FILLER          PIC X(10) VALUE 'REDEFINES '.
           05  FILLER          PIC X(18) VALUE 'HEX-DISPLAY-GROUP.'.

       01  HEX-DISPLAY-TABLE-02.
           05  FILLER          PIC x(15) VALUE '           05  '.
           05  FILLER          PIC X(18) VALUE 'HEX-DISPLAY-TABLE '.
           05  FILLER          PIC X(02) VALUE SPACES.
           05  FILLER          PIC X(07) VALUE 'pic XX '.
           05  FILLER          PIC X(18) VALUE 'OCCURS 256 TIMES. '.

       01  HEX-DISPLAY-BYTES.
           05  FILLER          PIC x(15) VALUE '           05  '.
           05  FILLER          PIC X(04) VALUE 'DSP-'.
           05  DSP-SYMBOL      PIC X(02) VALUE '00'.
           05  FILLER          PIC X(14) VALUE SPACES.
           05  FILLER          PIC X(14) VALUE "pic XX VALUE '".
           05  DSP-VALUE       PIC X(02) VALUE '00'.
           05  FILLER          PIC X(02) VALUE "'.".

       COPY BANNERB1.

       COPY BIN256B1.

      *****************************************************************
       PROCEDURE DIVISION.

           perform Z-POST-COPYRIGHT

           perform CREATE-A-BINARY-TABLE

           perform COMPARE-THE-TABLES

           perform CREATE-A-HEX-DECIMAL-COPY-FILE

           perform CREATE-A-HEX-DISPLAY-COPY-FILE

           perform Z-THANK-YOU.

           move ZERO to RETURN-CODE

           GOBACK.

      *****************************************************************
      * <A NAME="CompareTables">COMPARE-THE-TABLES</A>                  SIMOHTML
      * Compare hard-coded table from copy file to generated Table
      *
       COMPARE-THE-TABLES.
           if  BINARY-DATA = BIN-WORK-256
               move 'Binary Tables are equal' to MESSAGE-TEXT
           else
               move 'Binary Tables are NOT equal' to MESSAGE-TEXT
           end-if
           perform Z-DISPLAY-MESSAGE-TEXT
           exit.

      *****************************************************************
      * <A NAME="CreateBinaryTable">CREATE-A-BINARY-TABLE</A>           SIMOHTML
      * This routine will create a 256 byte text string containing the
      * hexadecimal values from X'00' through X'FF'.
      *
       CREATE-A-BINARY-TABLE.
           add 1 to ZERO giving BIN-WORK-02B
           add 1 to ZERO giving IX-1
           move BIN-WORK-02A to BIN-WORK-256(IX-1:2)
           perform 127 times
               add 2 to IX-1
               add 514 to BIN-WORK-02B
               move BIN-WORK-02A to BIN-WORK-256(IX-1:2)
           end-perform

           exit.

      *****************************************************************
      * <A NAME="CreateHexCopyFile">CREATE-A-HEX-DECIMAL-COPY-FILE</A>  SIMOHTML
      * This routine will create a COBOL copy file defining a 256 byte
      * text string containing the hexadecimal values from X'00'
      * through X'FF'.
      *
       CREATE-A-HEX-DECIMAL-COPY-FILE.
           perform HEXDECB1-OPEN
           move SPACES to HEXDECB1-REC
           perform DO-DEC-BANNER
           move HEX-DECIMAL-GROUP to HEXDECB1-REC
           perform HEXDECB1-WRITE
           add 1 to ZERO giving IX-1
           add 1 to ZERO giving IX-2
           perform 256 times
             move HEX-CHAR(IX-1:1) to HEX-SYMBOL(1:1)
             move HEX-CHAR(IX-2:1) to HEX-SYMBOL(2:1)
             move HEX-SYMBOL to HEX-VALUE
             move HEX-DECIMAL-BYTES to HEXDECB1-REC
             perform HEXDECB1-WRITE
             add 1 to IX-2
             if IX-2 > 16
                add 1 to IX-1
                add 1 to ZERO giving IX-2
             end-if
           end-perform

           move HEX-DECIMAL-TABLE to HEXDECB1-REC
           perform HEXDECB1-WRITE

           move HEX-DECIMAL-TABLE-02 to HEXDECB1-REC
           perform HEXDECB1-WRITE

           perform DO-DEC-BANNER
           perform HEXDECB1-CLOSE
           exit.

      *****************************************************************
      * <A NAME="CreateDspCopyFile">CREATE-A-HEX-DISPLAY-COPY-FILE</A>  SIMOHTML
      * This routine will create a COBOL copy file defining a 512 byte
      * text string containing 256 two (2) byte pairs of text values
      * representing the hex values from X'00' through X'FF'. The two
      * (2) byte text pairs may be printed or displayed.
      *
       CREATE-A-HEX-DISPLAY-COPY-FILE.
           perform HEXDSPB1-OPEN
           move SPACES to HEXDSPB1-REC
           perform DO-DSP-BANNER
           move HEX-DISPLAY-GROUP to HEXDSPB1-REC
           perform HEXDSPB1-WRITE
           add 1 to ZERO giving IX-1
           add 1 to ZERO giving IX-2
           perform 256 times
             move HEX-CHAR(IX-1:1) to DSP-SYMBOL(1:1)
             move HEX-CHAR(IX-2:1) to DSP-SYMBOL(2:1)
             move DSP-SYMBOL to DSP-VALUE
             move HEX-DISPLAY-BYTES to HEXDSPB1-REC
             perform HEXDSPB1-WRITE
             add 1 to IX-2
             if IX-2 > 16
                add 1 to IX-1
                add 1 to ZERO giving IX-2
             end-if
           end-perform

           move HEX-DISPLAY-TABLE to HEXDSPB1-REC
           perform HEXDSPB1-WRITE

           move HEX-DISPLAY-TABLE-02 to HEXDSPB1-REC
           perform HEXDSPB1-WRITE

           perform DO-DSP-BANNER
           perform HEXDSPB1-CLOSE
           exit.

      *****************************************************************
       DO-DEC-BANNER.
           move ALL '*' to HEXDECB1-REC(7:65)
           perform HEXDECB1-WRITE
           move SB-01 to SB-TEXT(6:51)
           move SIMOTIME-BANNER to HEXDECB1-REC
           perform HEXDECB1-WRITE
           move SB-02 to SB-TEXT(6:51)
           move SIMOTIME-BANNER to HEXDECB1-REC
           perform HEXDECB1-WRITE
           move SB-03 to SB-TEXT(6:51)
           move SIMOTIME-BANNER to HEXDECB1-REC
           perform HEXDECB1-WRITE
           move ALL '*' to HEXDECB1-REC(7:65)
           perform HEXDECB1-WRITE
           exit.

      *****************************************************************
       DO-DSP-BANNER.
           move ALL '*' to HEXDSPB1-REC(7:65)
           perform HEXDSPB1-WRITE
           move SB-01 to SB-TEXT(6:51)
           move SIMOTIME-BANNER to HEXDSPB1-REC
           perform HEXDSPB1-WRITE
           move SB-02 to SB-TEXT(6:51)
           move SIMOTIME-BANNER to HEXDSPB1-REC
           perform HEXDSPB1-WRITE
           move SB-03 to SB-TEXT(6:51)
           move SIMOTIME-BANNER to HEXDSPB1-REC
           perform HEXDSPB1-WRITE
           move ALL '*' to HEXDSPB1-REC(7:65)
           perform HEXDSPB1-WRITE
           exit.

      *****************************************************************
      * I/O Routines for the OUTPUT File...                           *
      *****************************************************************
       HEXDECB1-WRITE.
           if  HEXDECB1-OPEN-FLAG = 'C'
               perform HEXDECB1-OPEN
           end-if
           write HEXDECB1-REC
           if  HEXDECB1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  HEXDECB1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with HEXDECB1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move HEXDECB1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       HEXDECB1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT HEXDECB1-FILE
           if  HEXDECB1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to HEXDECB1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with HEXDECB1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move HEXDECB1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       HEXDECB1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close HEXDECB1-FILE
           if  HEXDECB1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to HEXDECB1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with HEXDECB1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move HEXDECB1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the OUTPUT File...                           *
      *****************************************************************
       HEXDSPB1-WRITE.
           if  HEXDSPB1-OPEN-FLAG = 'C'
               perform HEXDSPB1-OPEN
           end-if
           write HEXDSPB1-REC
           if  HEXDSPB1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  HEXDSPB1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with HEXDSPB1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move HEXDSPB1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       HEXDSPB1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT HEXDSPB1-FILE
           if  HEXDSPB1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to HEXDSPB1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with HEXDSPB1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move HEXDSPB1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       HEXDSPB1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close HEXDSPB1-FILE
           if  HEXDSPB1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to HEXDSPB1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with HEXDSPB1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move HEXDSPB1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           move SIM-TITLE to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           move SIM-COPYRIGHT to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           move SIM-THANKS-01 to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           move SIM-THANKS-02 to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
