       IDENTIFICATION DIVISION.
       PROGRAM-ID.    BINBITC2.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2016 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: BINBITC2.CBL
      *****************************************************************
      *
      * BINBITC2 - Create, Define and process binary tables.
      *
      * CALLING PROTOCOL
      * ----------------
      * Use standard procedure to RUN or ANIMATE.
      *
      * DESCRIPTION
      * -----------
      * This program will call a COBOL routine to access a
      * routine to convert between bits and bytes..
      *
      *          ************
      *          * BINBITJ1 *
      *          ********jcl*
      *               *
      *               *
      *          ************     ************
      *          * BINBITC2 *-----*  SYSOUT  *
      *          ********cbl*  *  ************
      *               *        *
      *               *        *  ************
      *               *        *--* HEXDECB1 *
      *               *           *******rseq*
      *               *        *
      *               *        *  ************
      *               *        *--* BINBITTX *
      *               *           *******rseq*
      *          ************
      *          *   EOJ    *
      *          ********cbl*
      *
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      * 1997/03/17 Simmons, Updated for call to SIMOBITS.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT BINBITTX-FILE  ASSIGN TO       BINBITTX
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS BINBITTX-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  BINBITTX-FILE
           DATA RECORD    IS BINBITTX-REC
           .
       01  BINBITTX-REC.
           05  BINBITTX-DATA-01 PIC X(00080).

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* BINBITC2 '.
           05  T2 pic X(34) value 'Process Hex Data using Copy Files '.
           05  T3 pic X(10) value ' v08.03.13'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* BINBITC2 '.
           05  C2 pic X(20) value 'Copyright 1987-2016 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* BINBITC2 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* BINBITC2 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  BINBITTX-STATUS.
           05  BINBITTX-STATUS-L     pic X.
           05  BINBITTX-STATUS-R     pic X.
       01  BINBITTX-EOF              pic X       value 'N'.
       01  BINBITTX-OPEN-FLAG        pic X       value 'C'.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *    ------------------------------------------------------------
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* BINBITC2 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  IX-1           pic 9(3) value 0.
       01  IX-2           pic 9(3) value 0.

       01  BIN-WORK-02A.
           05  BIN-WORK-02B    pic 9(3)    comp value 0.

       01  WORK-80             pic X(80)   value SPACES.


       COPY HEXDECB1.

       COPY HEXDSPB1.

      *****************************************************************
       PROCEDURE DIVISION.

           perform Z-POST-COPYRIGHT

           perform BINBITTX-OPEN

           perform WRITE-WITH-CARRIAGE-CONTROL

           perform WRITE-WITHOUT-CARRIAGE-CONTROL

           perform BINBITTX-CLOSE

           perform Z-THANK-YOU.

           move ZERO to RETURN-CODE

           GOBACK.

      *****************************************************************
       WRITE-WITH-CARRIAGE-CONTROL.
           move SPACES to WORK-80
           move 'Hello ' to WORK-80
           move HEX-0D to WORK-80(7:1)
           move HEX-0A to WORK-80(8:1)
           move 'Hello Again' to WORK-80(9:11)
           move HEX-0D to WORK-80(20:1)
           move HEX-0A to WORK-80(21:1)

           add 1 to ZERO giving IX-1
           add 22 to ZERO giving IX-2
           move SPACES to BINBITTX-REC
           perform 21 times
             move WORK-80(IX-1:1) to BIN-WORK-02A(2:1)
             compute BIN-WORK-02B = (BIN-WORK-02B * 2) + 1
             move HEX-DISPLAY-GROUP(BIN-WORK-02B:2)
               to WORK-80(IX-2:2)
             add 1 to IX-1
             add 2 to IX-2
           end-perform
           move HEX-0D to WORK-80(79:1)
           move HEX-0A to WORK-80(80:1)

           move WORK-80 to BINBITTX-REC
           perform BINBITTX-WRITE
           exit.

      *****************************************************************
       WRITE-WITHOUT-CARRIAGE-CONTROL.
           move SPACES to WORK-80
           move 'Hello ' to WORK-80
      *    move HEX-0D to WORK-80(7:1)
      *    move HEX-0A to WORK-80(8:1)
           move 'Hello Again' to WORK-80(9:11)
      *    move HEX-0D to WORK-80(20:1)
      *    move HEX-0A to WORK-80(21:1)

           add 1 to ZERO giving IX-1
           add 22 to ZERO giving IX-2
           move SPACES to BINBITTX-REC
           perform 21 times
             move WORK-80(IX-1:1) to BIN-WORK-02A(2:1)
             compute BIN-WORK-02B = (BIN-WORK-02B * 2) + 1
             move HEX-DISPLAY-GROUP(BIN-WORK-02B:2)
               to WORK-80(IX-2:2)
             add 1 to IX-1
             add 2 to IX-2
           end-perform
      *    move HEX-0D to WORK-80(79:1)
      *    move HEX-0A to WORK-80(80:1)

           move WORK-80 to BINBITTX-REC
           perform BINBITTX-WRITE
           exit.

      *****************************************************************
      * I/O Routines for the OUTPUT File...                           *
      *****************************************************************
       BINBITTX-WRITE.
           if  BINBITTX-OPEN-FLAG = 'C'
               perform BINBITTX-OPEN
           end-if
           write BINBITTX-REC
           if  BINBITTX-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  BINBITTX-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with BINBITTX' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move BINBITTX-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       BINBITTX-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT BINBITTX-FILE
           if  BINBITTX-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to BINBITTX-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with BINBITTX' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move BINBITTX-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       BINBITTX-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close BINBITTX-FILE
           if  BINBITTX-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to BINBITTX-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with BINBITTX' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move BINBITTX-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           move SIM-TITLE to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           move SIM-COPYRIGHT to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           move SIM-THANKS-01 to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           move SIM-THANKS-02 to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
