@echo OFF
rem  * *******************************************************************
rem  *               BINBITE1.CMD - a Windows Command File               *
rem  *         This program is provided by SimoTime Technologies         *
rem  *           (C) Copyright 1987-2016 All Rights Reserved             *
rem  *             Web Site URL:   http://www.simotime.com               *
rem  *                   e-mail:   helpdesk@simotime.com                 *
rem  * *******************************************************************
rem  *
rem  * Text   - Describe how to create, define, access or process Text
rem  *          strings or tables with binary values.
rem  * Author - SimoTime Technologies
rem  * Date   - January 24, 1996
rem  *
rem  * The job will create two (2) COBOL Copy Files.
rem  * 1. The 1st copy file will define a table with 256 elements of
rem  *    one byte binary values from x'00' through x'FF'.
rem  * 2. The 2nd copy file will define a table 2ith 256 elements of
rem  *    two byte display values that map to the binary values defined
rem  *    by the 1st copy file.
rem  *
rem  * This set of programs will run on a mainframe under MVS or on a
rem  * Personal Computer with Windows and Micro Focus Net Express.
rem  *
rem  *          ************
rem  *          * BINBITE1 *
rem  *          ********cmd*
rem  *               *
rem  *               *
rem  *          ************     ************
rem  *          * BINBITC1 *-----*  SYSOUT  *
rem  *          ********cbl*  *  ************
rem  *               *        *
rem  *               *        *  ************
rem  *               *        *--* HEXDECB1 *
rem  *               *           *******rseq*
rem  *               *        *
rem  *               *        *  ************
rem  *               *        *--* HEXDSPB1 *
rem  *               *           *******rseq*
rem  *               *
rem  *               *
rem  *          ************     ************
rem  *          * BINBITC1 *-----*  SYSOUT  *
rem  *          ********cbl*  *  ************
rem  *               *        *
rem  *               *        *  ************
rem  *               *        *--* HEXDECB1 *
rem  *               *           *******lseq*
rem  *               *        *
rem  *               *        *  ************
rem  *               *        *--* HEXDSPB1 *
rem  *               *           *******lseq*
rem  *               *
rem  *          ************
rem  *          *   EOJ    *
rem  *          ********cbl*
rem  *
rem  * *******************************************************************
rem  * Step 1, Delete any previously created file...
rem  *
     set CmdName=BinBite1
     call ..\Env1BASE %CmdName%
     if "%SYSLOG%" == "" set syslog=c:\SimoLIBR\LOGS\SimoTime.LOG
rem  *
     call SimoNOTE "*******************************************************%CmdName%"
     call SimoNOTE "Starting CmdName %CmdName%, V08.06.05, User is %USERNAME%"
     call SimoNOTE "StepInfo Delete previously created files"
     set HEXDECB1=%BaseLib1%\DATA\Wrk1\HEXDECB1.DAT
     set HEXDSPB1=%BaseLib1%\DATA\Wrk1\HEXDSPB1.DAT
     if exist %HEXDECB1% del %HEXDECB1%
     if exist %HEXDSPB1% del %HEXDSPB1%
rem  *
rem  * *******************************************************************
rem  * Step 2, Edit input, create a new output file...
rem  *
     call SimoNOTE "StepInfo Create Record Sequential files"
     run BINBITC1
     if not ERRORLEVEL = 0 set JobStatus=0020
     if not %JobStatus% == 0000 goto :EojNok
rem  *
     if exist %HEXDECB1% goto :Jump01
     set JobStatus=0020
     goto :EojNok
:Jump01
     if exist %HEXDSPB1% goto :Jump02
     set JobStatus=0030
     goto :EojNok
:Jump02
     call SimoNOTE "DataMake %HEXDECB1%"
     call SimoNOTE "DataMake %HEXDSPB1%"
rem  *
rem  * *******************************************************************
rem  * Step 3, Read Record Sequential Files, write Line Sequential Files.
rem  *
     call SimoNOTE "StepInfo Create Copy File, HexTable of 256 elements of 1 byte each"
     set GETRS080=%HEXDECB1%
     set PUTLS080=%BaseLib1%\DATA\Wrk1\HEXDECB1.CPY
     run CV80ARAL
     if not ERRORLEVEL = 0 set JobStatus=0031
     if not %JobStatus% == 0000 goto :EojNok
     call SimoNOTE "DataTake %GETRS080%"
     call SimoNOTE "DataMake %PUTLS080%"
rem  *
     call SimoNOTE "StepInfo Create Copy File, Display Table of 256 elements of 2 bytes each"
     set GETRS080=%HEXDSPB1%
     set PUTLS080=%BaseLib1%\DATA\Wrk1\HEXDSPB1.CPY
     run CV80ARAL
     if not ERRORLEVEL = 0 set JobStatus=0032
     if not %JobStatus% == 0000 goto :EojNok
     call SimoNOTE "DataTake %GETRS080%"
     call SimoNOTE "DataMake %PUTLS080%"
:EojAok
     call SimoNOTE "Finished JobName %CmdName%, Job Status is %JobStatus% "
     goto :End
:EojNok
     call SimoNOTE "ABENDING JobName %CmdName%, Job Status is %JobStatus% "
:End
     if not "%1" == "nopause" pause
