//BINBITJ1 JOB SIMOTIME,CLASS=1,MSGCLASS=0,NOTIFY=CSIP1
//* *******************************************************************
//*       BINBITJ1.JCL - a JCL Member for Batch Job Processing        *
//*       This JCL Member is provided by SimoTime Technologies        *
//*           (C) Copyright 1987-2016 All Rights Reserved             *
//*             Web Site URL:   http://www.simotime.com               *
//*                   e-mail:   helpdesk@simotime.com                 *
//* *******************************************************************
//*
//* Text   - Describe how to create, define, access or process Text
//*          strings or tables with binary values.
//* Author - SimoTime Technologies
//* Date   - January 24, 1996
//*
//* The job will create two (2) COBOL Copy Files.
//*
//* 1. The 1st copy file will define a table with 256 elements of
//*    one byte binary values from x'00' through x'FF'.
//* 2. The 2nd copy file will define a table 2ith 256 elements of
//*    two byte display values that map to the binary values defined
//*    by the 1st copy file.
//*
//* This set of programs will run on a mainframe under MVS or on a
//* Personal Computer with Windows and Micro Focus Net Express.
//*
//*          ************
//*          * BINBITJ1 *
//*          ********jcl*
//*               *
//*               *
//*          ************     ************
//*          * BINBITC1 *-----*  SYSOUT  *
//*          ********cbl*  *  ************
//*               *        *
//*               *        *  ************
//*               *        *--* HEXDECB1 *
//*               *           *******rseq*
//*               *        *
//*               *        *  ************
//*               *        *--* HEXDSPB1 *
//*               *           *******rseq*
//*               *
//*               *
//*          ************     ************
//*          * BINBITC1 *-----*  SYSOUT  *
//*          ********cbl*  *  ************
//*               *        *
//*               *        *  ************
//*               *        *--* HEXDECB1 *
//*               *           *******pdsm*
//*               *        *
//*               *        *  ************
//*               *        *--* HEXDSPB1 *
//*               *           *******pdsm*
//*               *
//*          ************
//*          *   EOJ    *
//*          ********cbl*
//*
//* *******************************************************************
//* Step   1   Delete any previously created file...
//*
//CLEANUP1 EXEC PGM=IEFBR14
//HEXDECB1 DD  DSN=SIMOTIME.DATA.HEXDECB1,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//HEXDSPB1 DD  DSN=SIMOTIME.DATA.HEXDSPB1,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//*
//* *******************************************************************
//* Step   2   Create two Record Sequential Files (RSEQ)...
//*
//BINBITS1 EXEC PGM=BINBITC1
//STEPLIB  DD  DSN=SIMOTIME.DEMO.LOADLIB1,DISP=SHR
//HEXDECB1 DD  DSN=SIMOTIME.DATA.HEXDECB1,
//             DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//HEXDSPB1 DD  DSN=SIMOTIME.DATA.HEXDSPB1,
//             DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=800,DSORG=PS)
//SYSOUT   DD  SYSOUT=*
//*
//* *******************************************************************
//* Step   3   Create two PDS Members (PDSM)...
//*
//BINBITS1 EXEC PGM=BINBITC1
//STEPLIB  DD  DSN=SIMOTIME.DEMO.LOADLIB1,DISP=SHR
//HEXDECB1 DD  DSN=SIMOTIME.PDS.COBCPY7(HEXDECB1),
//             DISP=SHR
//HEXDSPB1 DD  DSN=SIMOTIME.PDS.COBCPY7(HEXDSPB1),
//             DISP=SHR
//SYSOUT   DD  SYSOUT=*
//
